--compare the love.mouse.isDown, normally called in the love.update(), and the love.mousepressed and love.mousereleased callbacks usage
function love.load()
  mouseDownUpdate = 0
  mousePressedCallback = 0
  
  BUTTON_X, BUTTON_Y, BUTTON_W, BUTTON_H = 370, 30, 60, 30
  function checkMouseVsButton(mx, my)
    return mx > BUTTON_X and mx < (BUTTON_X + BUTTON_W) and my > BUTTON_Y and my < (BUTTON_Y + BUTTON_H)
  end
  
  isMouseOverButton = false
  isButtonDown = false
end

function love.update(dt)
  isMouseOverButton = checkMouseVsButton(love.mouse.getPosition())
  if love.mouse.isDown("l") then
    mouseDownUpdate = isMouseOverButton and (mouseDownUpdate + dt) or mouseDownUpdate
  end
end

function love.draw()
  local y = 30
  
  love.graphics.print("[Instruction] Click and hold left mouse button on this: ", 30, y); y = y + 15
  love.graphics.print("[Instruction] Reset only if released on button.", 30, y); y = y + 15
  love.graphics.print(string.format("[Info] LMB is pressed as long as %f second", mouseDownUpdate), 30, y); y = y + 15
  love.graphics.print(string.format("[Info] LMB has been released as much as %d times", mousePressedCallback), 30, y)
  
  if isButtonDown then
    love.graphics.setColor(150, 250, 150, 200)
  else
    love.graphics.setColor(255, 255, 255, 100)
  end
  love.graphics.rectangle("fill", BUTTON_X, BUTTON_Y, BUTTON_W, BUTTON_H)
  
  love.graphics.setColor(255, 255, 255, 255)
  if isMouseOverButton then
    love.graphics.rectangle("line", BUTTON_X, BUTTON_Y, BUTTON_W, BUTTON_H)
  end
end

function love.mousepressed(mx, my, button)
  if button == "l" and isMouseOverButton then
    isButtonDown = true
  end
end

function love.mousereleased(mx, my, button)
  if button == "l" then
    mousePressedCallback = mousePressedCallback + 1
    isButtonDown = false
    if isMouseOverButton then
      mouseDownUpdate = 0
    end
  end
end

function love.keypressed(key)
  if key == "escape" then
    love.event.push("quit")
  end
end